系统城装机大师 - 固镇县祥瑞电脑科技销售部宣传站!

当前位置:首页 > 脚本中心 > per > 详细页面

Linux下用Nginx作Perl程序服务器及其中Perl模块的配置

时间:2020-02-13来源:系统城作者:电脑系统城

这篇文章主要介绍了Linux下用Nginx作Perl程序服务器及其中Perl模块的配置,文中使用到了FastCGI中间件进行连接,需要的朋友可以参考下

perl + fastcgi + nginx搭建

nginx + fastcgi是php下最流行的一套环境了,那perl会不会也有fastcgi呢,当然有,今天来搭建下nginx下perl的fastcgi.性能方面也不亚于php,但是现在web程序php的流行程度perl无法比拟了,性能再好也枉然,但是部分小功能可以考虑使用perl的fastcgi来搞定.进入正题.
1. 准备软件环境:

nginx:http://www.nginx.org
perl:系统自带
fastcgi:http://www.cpan.org/modules/by-module/FCGI/
1.1 nginx安装
这里就不再详细介绍了~
1.2 perl安装
一般linux都有自带perl,可以不用安装,如果确实没有,请执行:


 
  1. # yum install perl

1.3 perl-fastcgi安装


 
  1. # cd /usr/local/src
  2. # wget http://www.cpan.org/modules/by-module/FCGI/FCGI-0.74.tar.gz
  3. # tar -xzvf FCGI-0.74.tar.gz
  4. # cd FCGI-0.74
  5. # perl Makefile.PL
  6. # make
  7. # make install

2. nginx虚拟主机配置


 
  1. server {
  2.  
  3. listen 80;
  4. server_name test.jb51.net;
  5. #access_log /data/logs/nginx/test.jb51.net.access.log main;
  6.  
  7. index index.html index.php index.html;
  8. root /data/site/test.jb51.net;
  9.  
  10. location /
  11. {
  12.  
  13. }
  14.  
  15. location ~ \.pl$
  16. {
  17. include fastcgi_params;
  18. fastcgi_pass 127.0.0.1:8999;
  19. #fastcgi_pass unix:/var/run/jb51.net.perl.sock;
  20. fastcgi_index index.pl;
  21. }
  22. }

如果想把tcp/ip方式改为socket方式,可以修改fastcgi-wrapper.pl.


 
  1. $socket = FCGI::OpenSocket( "127.0.0.1:8999", 10 ); #use IP sockets

改为


 
  1. $socket = FCGI::OpenSocket( "/var/run/jb51.net.perl.sock", 10 ); #use IP sockets

3. 配置脚本

3.1 fastcgi监听脚本
文件路径:/usr/bin/fastcgi-wrapper.pl


 
  1. #!/usr/bin/perl
  2.  
  3. use FCGI;
  4. use Socket;
  5. use POSIX qw(setsid);
  6.  
  7. require 'syscall.ph';
  8.  
  9. &daemonize;
  10.  
  11. #this keeps the program alive or something after exec'ing perl scripts
  12. END() { } BEGIN() { }
  13. *CORE::GLOBAL::exit = sub { die "fakeexit\nrc=".shift()."\n"; };
  14. eval q{exit};
  15. if ($@) {
  16. exit unless $@ =~ /^fakeexit/;
  17. };
  18.  
  19. &main;
  20.  
  21. sub daemonize() {
  22. chdir '/' or die "Can't chdir to /: $!";
  23. defined(my $pid = fork) or die "Can't fork: $!";
  24. exit if $pid;
  25. setsid or die "Can't start a new session: $!";
  26. umask 0;
  27. }
  28.  
  29. sub main {
  30. $socket = FCGI::OpenSocket( "127.0.0.1:8999", 10 ); #use IP sockets
  31. $request = FCGI::Request( \*STDIN, \*STDOUT, \*STDERR, \%req_params, $socket );
  32. if ($request) { request_loop()};
  33. FCGI::CloseSocket( $socket );
  34. }
  35.  
  36. sub request_loop {
  37. while( $request->Accept() >= 0 ) {
  38.  
  39. #processing any STDIN input from WebServer (for CGI-POST actions)
  40. $stdin_passthrough ='';
  41. $req_len = 0 + $req_params{'CONTENT_LENGTH'};
  42. if (($req_params{'REQUEST_METHOD'} eq 'POST') && ($req_len != 0) ){
  43. my $bytes_read = 0;
  44. while ($bytes_read < $req_len) {
  45. my $data = '';
  46. my $bytes = read(STDIN, $data, ($req_len - $bytes_read));
  47. last if ($bytes == 0 || !defined($bytes));
  48. $stdin_passthrough .= $data;
  49. $bytes_read += $bytes;
  50. }
  51. }
  52.  
  53. #running the cgi app
  54. if ( (-x $req_params{SCRIPT_FILENAME}) && #can I execute this?
  55. (-s $req_params{SCRIPT_FILENAME}) && #Is this file empty?
  56. (-r $req_params{SCRIPT_FILENAME}) #can I read this file?
  57. ){
  58. pipe(CHILD_RD, PARENT_WR);
  59. my $pid = open(KID_TO_READ, "-|");
  60. unless(defined($pid)) {
  61. print("Content-type: text/plain\r\n\r\n");
  62. print "Error: CGI app returned no output - ";
  63. print "Executing $req_params{SCRIPT_FILENAME} failed !\n";
  64. next;
  65. }
  66. if ($pid > 0) {
  67. close(CHILD_RD);
  68. print PARENT_WR $stdin_passthrough;
  69. close(PARENT_WR);
  70.  
  71. while(my $s = <KID_TO_READ>) { print $s; }
  72. close KID_TO_READ;
  73. waitpid($pid, 0);
  74. } else {
  75. foreach $key ( keys %req_params){
  76. $ENV{$key} = $req_params{$key};
  77. }
  78. # cd to the script's local directory
  79. if ($req_params{SCRIPT_FILENAME} =~ /^(.*)\/[^\/]+$/) {
  80. chdir $1;
  81. }
  82.  
  83. close(PARENT_WR);
  84. close(STDIN);
  85. #fcntl(CHILD_RD, F_DUPFD, 0);
  86. syscall(&SYS_dup2, fileno(CHILD_RD), 0);
  87. #open(STDIN, "<&CHILD_RD");
  88. exec($req_params{SCRIPT_FILENAME});
  89. die("exec failed");
  90. }
  91. }
  92. else {
  93. print("Content-type: text/plain\r\n\r\n");
  94. print "Error: No such CGI app - $req_params{SCRIPT_FILENAME} may not ";
  95. print "exist or is not executable by this process.\n";
  96. }
  97.  
  98. }
  99. }

3.2 fastcgi自启动服务脚本:

文件路径:/etc/rc.d/init.d/perl-fastcgi

文件路径:/etc/rc.d/init.d/perl-fastcgi
 


 
  1. #!/bin/sh
  2. #
  3. # nginx – this script starts and stops the nginx daemon
  4. #
  5. # chkconfig: - 85 15
  6. # description: Nginx is an HTTP(S) server, HTTP(S) reverse \
  7. # proxy and IMAP/POP3 proxy server
  8. # processname: nginx
  9. # config: /opt/nginx/conf/nginx.conf
  10. # pidfile: /opt/nginx/logs/nginx.pid
  11.  
  12. # Source function library.
  13. . /etc/rc.d/init.d/functions
  14.  
  15. # Source networking configuration.
  16. . /etc/sysconfig/network
  17.  
  18. # Check that networking is up.
  19. [ "$NETWORKING" = "no" ] && exit 0
  20.  
  21. perlfastcgi="/usr/bin/fastcgi-wrapper.pl"
  22. prog=$(basename perl)
  23.  
  24. lockfile=/var/lock/subsys/perl-fastcgi
  25.  
  26. start() {
  27. [ -x $perlfastcgi ] || exit 5
  28. echo -n $"Starting $prog: "
  29. daemon $perlfastcgi
  30. retval=$?
  31. echo
  32. [ $retval -eq 0 ] && touch $lockfile
  33. return $retval
  34. }
  35.  
  36. stop() {
  37. echo -n $"Stopping $prog: "
  38. killproc $prog -QUIT
  39. retval=$?
  40. echo
  41. [ $retval -eq 0 ] && rm -f $lockfile
  42. return $retval
  43. }
  44.  
  45. restart() {
  46. stop
  47. start
  48. }
  49.  
  50. reload() {
  51. echo -n $”Reloading $prog: ”
  52. killproc $nginx -HUP
  53. RETVAL=$?
  54. echo
  55. }
  56.  
  57. force_reload() {
  58. restart
  59. }
  60. rh_status() {
  61. status $prog
  62. }
  63.  
  64. rh_status_q() {
  65. rh_status >/dev/null 2>&1
  66. }
  67.  
  68. case "$1" in
  69. start)
  70. rh_status_q && exit 0
  71. $1
  72. ;;
  73. stop)
  74. rh_status_q || exit 0
  75. $1
  76. ;;
  77. restart)
  78. $1
  79. ;;
  80. reload)
  81. rh_status_q || exit 7
  82. $1
  83. ;;
  84. force-reload)
  85. force_reload
  86. ;;
  87. status)
  88. rh_status
  89. ;;
  90. condrestart|try-restart)
  91. rh_status_q || exit 0
  92. ;;
  93. *)
  94. echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload}"
  95. exit 2
  96. esac

3.3 设置脚本权限


 
  1. # chmod a+x /usr/bin/fastcgi-wrapper.pl
  2. # chmod a+x /etc/rc.d/init.d/perl-fastcgi
  3.  


4. FastCGI测试
4.1 启动nginx与fastcgi


 
  1. # /usr/local/nginx-1.4.2/sbin/nginx
  2. # /etc/init.d/perl-fastcgi start

4.2 perl测试文件:
文件路径/data/site/test.jb51.net/test.pl


 
  1. #!/usr/bin/perl
  2.  
  3. print "Content-type:text/html\n\n";
  4. print <<EndOfHTML;
  5. <html><head><title>Perl Environment Variables</title></head>
  6. <body>
  7. <h1>Perl Environment Variables</h1>
  8. EndOfHTML
  9.  
  10. foreach $key (sort(keys %ENV)) {
  11. print "$key = $ENV{$key}<br>\n";
  12. }
  13.  
  14. print "</body></html>";
  15.  

5. 访问测试

5.1 访问
http://http:test.jb51.net/test.pl,出现内容表示OK.
 
6. 简单压力测试:
6.1 使用tcp/ip方式


 
  1. ab -n 1000 -c 10 http://test.jb51.net/test.pl

他是在是太慢了,只好用10个并发,共计100个请求来测试.

201621100220855.jpg (616×191)

6.2 使用socket方式:


 
  1. ab -n 100000 -c 500 http://test.jb51.net/test.pl

201621100303553.jpg (616×227)

很奇怪,使用tcp/ip方式,每秒就140多个请求,而使用socket方式却有5800个请求/秒。差距不是一般的大。顺便测试了一下php的fastcgi,大概请求在3000(tcp/ip方式),4800(socket方式)。

 

perl模块的使用
如果对于一个绝大部分内容是静态的网站,只有极少数的地方需要动态显示,碰巧你又了解一点perl知识,那么nginx + perl的结合就能很好解决问题。要想nginx支持perl脚本,在编译nginx时候需要如下参数:


 
  1. ./configure --with-http_perl_module

如果make时候出现如下类似错误:


 
  1. Can't locate ExtUtils/Embed.pm in @INC (@INC contains: /usr/lib/perl5/5.10.0/i386-linux-thread-multi /usr/lib/perl5/5.10.0 /usr/local/lib/perl5/site_perl/5.10.0/i386-linux-thread-multi /usr/local/lib/perl5/site_perl/5.10.0 /usr/lib/perl5/vendor_perl/5.10.0/i386-linux-thread-multi /usr/lib/perl5/vendor_perl/5.10.0 /usr/lib/perl5/vendor_perl /usr/local/lib/perl5/site_perl .)

你的机器上可能需要安装perl-devel perl-ExtUtils-Embed,对于centos系统,直接使用yum搞定,例如:


 
  1. yum -y install perl-devel perl-ExtUtils-Embed

nginx中使用perl有两种方法,一种是直接在配置文件写,还有一种是把perl脚本写在外部文件中,下面主要介绍一下第二种用法。
假设nginx的根目录为/usr/local/nginx,perl脚本存放的目录为nginx的根目录下的perl/lib下,脚本名字为test.pm,nginx配置为:


 
  1. #位于http配置中
  2. perl_modules perl/lib;
  3. perl_require test.pm;
  4.  
  5. #位于server配置中
  6. location /user/ {
  7. perl pkg_name::process;
  8. }

上述配置是把所有来自http://servername/user/下的请求交由test.pm脚本中定义的process方法来处理。
test.pm脚本的内容如下:


 
  1. package pkg_name;
  2.  
  3. use Time::Local;
  4. use nginx;
  5.  
  6. sub process {
  7. my $r = shift;
  8.  
  9. $r->send_http_header('text/html; charset=utf-8');
  10. my @arr = split('/', $r->uri);
  11. my $username = @arr[2];
  12.  
  13. if (!$username || ($username eq "")) {
  14. $username = "Anonymous";
  15. }
  16.  
  17. $r->print('Hello, You name is : <strong>' . $username . '</strong>');
  18. $r->rflush();
  19. return;
  20. }
  21.  
  22. 1;
  23. __END__

当你访问http://servername/user/netingcn,你应该可以在网页上看到:


 
  1. Hello, You name is : netingcn

另外:当使用 use nginx 时,会有如下的对象可以调用,可以看到上面 shift 一个对象到 $r 上,然后就可以用 $r 调用那些对象了:

  • $r->args – 请求的参数 .
  • $r->discard_request_body – 这个参数是让 Nginx 放弃 request 的 body 的内容.
  • $r->filename – 返回合适的请求文件的名字
  • $r->has_request_body(function) – 如果没有请求主体,返回0,但是如果请求主体存在,那么建立传递的函数并返回1,在程序的最后,nginx将调用指定的处理器.
  • $r->header_in(header) – 查找请求头的信息
  • $r->header_only – 如果我们只要返回一个响应的头
  • $r->header_out(header, value) – 设置响应的头
  • $r->internal_redirect(uri) – 使内部重定向到指定的URI,重定向仅在完成perl脚本后发生.可以使用 header_out(Location….的方法来让浏览器自己重定向
  • $r->print(args, …) – 发送数据给客户端
  • $r->request_body – 得到客户端提交过来的内容 (body 的参数,可能需要修改 nginx 的 client_body_buffer_size. )
  • $r->request_body_file —给客户的 body 存成文件,并返回文件名
  • $r->request_method — 得到请求 HTTP method.
  • $r->remote_addr – 得到客户端的 IP 地址.
  • $r->rflush – 立即传送数据给客户端
  • $r->sendfile(file [, displacement [, length ] ) – 传送给客户端指定文件的内容,可选的参数表明只传送数据的偏移量与长度,精确的传递仅在perl脚本执行完毕后生效.这可是所谓的高级功能啊
  • $r->send_http_header(type) – 添加一个回应的 http 头的信息
  • $r->sleep(milliseconds, handler) – 设置为请求在指定的时间使用指定的处理方法和停止处理,在此期间nginx将继续处理其他的请求,超过指定的时间后,nginx将运行安装的处理方法,注意你需要为处理方法通过一个reference,在处理器间转发数据你可以使用$r->variable().
  • $r->status(code) – 设置 http 的响应码
  • $r->unescape(text) – 使用 http 方法加密内容如 %XX
  • $r->uri – 得到请求的 URL.
  • $r->variable(name[, value]) – 设置变量的值
分享到:

相关信息

系统教程栏目

栏目热门教程

人气教程排行

站长推荐

热门系统下载